' FFSubmenu=Skalieren
' FFName=Scalefix
' Alle selektierten Bilder werden unter Beibehaltung des
' Seitenverhltnisses auf die eingegebene Gre skaliert.
' Die kleinere Seite wird in der eingestellten Farbe erweitert.
option explicit
dim res,dlg,ctl_w,ctl_h,ctl_c, dc
dim ctl_wt,ctl_ht,ctl_ct,ctl_p,ctl_pi,ctl_do
dim i,imagecount,width,height,r,g,b,w,h
dim links,rechts,oben,unten
dim fso,path,dir,file,ext,pvpath
set fso = CreateObject("Scripting.FileSystemObject")

dlg = "FFScript: Einheitsgre"
ctl_w = "width"
ctl_wt = "max. Breite"
ctl_h = "height"
ctl_ht = "max. Hhe"
ctl_c = "color"
ctl_ct = "Farbe der Randerweiterung"
ctl_p = "Vorschau"
ctl_pi = "preview"
ctl_do = "Ausfhren"
imagecount = FF_GetImageCount
call FF_AddDialog(dlg,134,180)

call FF_AddControl(dlg,ctl_w,"EDIT",2,2,20,8)
call FF_AddControl(dlg,ctl_wt,"STATIC",24,2,36,8)
call FF_AddControl(dlg,ctl_h,"EDIT",64,2,20,8)
call FF_AddControl(dlg,ctl_ht,"STATIC",86,2,36,8)
call FF_AddControl(dlg,ctl_ct,"STATIC",2,12,128,8)
call FF_AddControl(dlg,ctl_c,"COLOR",2,20,73,10)
call FF_AddControl(dlg,ctl_p,"BUTTON",77,20,52,10)
call FF_AddControl(dlg,ctl_pi,"IMAGE",2,32,128,128)
call FF_AddControl(dlg,ctl_do,"BUTTON",77,162,52,10)

call FF_SetControl(dlg,ctl_w,"100")
call FF_SetControl(dlg,ctl_h,"100")
call FF_SetControl(dlg,ctl_c,"255 255 255")

do
 call FF_ActivateControl(dlg,ctl_w)
 dc = 1
 res = FF_ShowDialog(dlg)
 width = FF_GetControl(dlg,ctl_w)
 height = FF_GetControl(dlg,ctl_h)
 path = FF_GetControl(dlg,ctl_c)
 r = Mid(path,1,3)
 g = Mid(path,5,3)
 b = Mid(path,9,3)
 select case res
  case ctl_do
   if width > 0 then
    if height > 0 then
     FF_CloseDialog dlg
     dc = 0
     call Process()
     exit do
    end if
   end if
  case ctl_p
   if width > 0 then
    if height > 0 then
     call Preview()
    end if
   end if
  case "CANCEL"
   exit do
 end select
loop

if dc = 1 then FF_CloseDialog dlg   

if pvpath <> "" then
 call fso.DeleteFile(pvpath)
end if

' Skalierung aller Bilder durchfhren
sub Process
 for i=0 to imagecount-1
  path = FF_GetImageName(i)
  call FF_LoadImage(path)
  call StepScale(width,height)
  w = FF_GetImageWidth()
  h = FF_GetImageHeight()
  links = int((width - w) / 2 + 0.5)
  rechts = width - w - links
  oben = int((height - h) / 2 + 0.5)
  unten = height - h - oben
  call FF_ExtendCanvas(links,rechts,oben,unten,r,g,b)
  call SplitPath(path,dir,file,ext)
  call FF_SaveImage(dir & "Mini_" & file & ext,0)
  call FF_SetProgress(i+1,imagecount)
 next
end sub

sub Preview
 path = FF_GetImageName(0)
 call FF_LoadImage(path)
 call StepScale(width,height)
 w = FF_GetImageWidth()
 h = FF_GetImageHeight()
 links = int((width - w) / 2 + 0.5)
 rechts = width - w - links
 oben = int((height - h) / 2 + 0.5)
 unten = height - h - oben
 call FF_ExtendCanvas(links,rechts,oben,unten,r,g,b)
 call SplitPath(path,dir,file,ext)
 pvpath = dir & "FFScript_Temp.jpg"
 call FF_SaveImage(pvpath,0)
 call FF_SetControl(dlg,ctl_pi,pvpath)
end sub

' liefert Verzeichnis mit abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
sub SplitPath(path, byref dir, byref file, byref ext)
 dir = fso.GetParentFolderName(path) & "\"
 file = fso.GetBaseName(path)
 ext = "." & fso.GetExtensionName(path)
end sub

' Schrittweise verkleinern mit Zwischenschrfen
sub StepScale(width,height)
 do
  w = FF_GetImageWidth()
  h = FF_GetImageHeight()
  if(w < width * 2) then exit do
  if(h < height * 2) then exit do
  call FF_Sharp(32,true,true,true)
  call FF_HQScale(w/2,h/2,true)
 loop
 call FF_Sharp(32,true,true,true)
 call FF_HQScale(width,height,true)
end sub
